"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var connect_1 = require("@dapp-stack/connect");
var environment_1 = require("@dapp-stack/environment");
var ethers = require("ethers");
var path = require("path");
var fs = require("fs-extra");
var keythereum = require("keythereum");
var signale_1 = require("signale");
var signale = new signale_1.Signale({ scope: 'Wallet' });
exports.generateWallet = function (network, mnemonic) {
    if (network === void 0) { network = false; }
    return __awaiter(_this, void 0, void 0, function () {
        var ethereum, provider;
        return __generator(this, function (_a) {
            if (!network || !mnemonic) {
                ethereum = environment_1.build().ethereum;
                if (!ethereum) {
                    return [2 /*return*/, { balance: new ethers.utils.BigNumber(0) }];
                }
                network = ethereum.network;
                mnemonic = ethereum.mnemonic;
            }
            provider = connect_1.connect(network);
            if (network === 'dev') {
                return [2 /*return*/, devWallet(provider)];
            }
            if (mnemonic) {
                return [2 /*return*/, mnemonicWallet(mnemonic, provider)];
            }
            return [2 /*return*/, { provider: provider, balance: new ethers.utils.BigNumber(0) }];
        });
    });
};
var devWallet = function (provider) { return __awaiter(_this, void 0, void 0, function () {
    var addresses, address, balance, signer, privateKey;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, provider.listAccounts()];
            case 1:
                addresses = _a.sent();
                address = addresses[0];
                return [4 /*yield*/, provider.getBalance(address)];
            case 2:
                balance = _a.sent();
                signer = provider.getSigner();
                signale.success('Dev Wallet:');
                signale.success("Address: " + address);
                signale.success("Balance: " + ethers.utils.formatEther(balance) + " Eth");
                if (process.env.DAPP_ENV !== 'test') {
                    privateKey = getPrivateKey();
                    signale.success("Private key: " + privateKey);
                }
                return [2 /*return*/, { provider: provider, address: address, balance: balance, signer: signer }];
        }
    });
}); };
var getPrivateKey = function () {
    signale.await('Generating private key...');
    var keystore = path.join(process.cwd(), '.geth', 'keystore');
    var filename = fs.readdirSync(keystore)[0];
    var keyObject = fs.readJSONSync(path.join(keystore, filename));
    return keythereum.recover('', keyObject).toString('hex');
};
var mnemonicWallet = function (mnemonic, provider) { return __awaiter(_this, void 0, void 0, function () {
    var wallet, balance;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                wallet = ethers.Wallet.fromMnemonic(mnemonic).connect(provider);
                return [4 /*yield*/, wallet.getBalance()];
            case 1:
                balance = _a.sent();
                signale.success('Mnemonic Wallet:');
                signale.success("Address: " + wallet.address);
                signale.success("Balance: " + ethers.utils.formatEther(balance) + " Eth");
                signale.success("Mnemonic: " + mnemonic);
                return [2 /*return*/, { address: wallet.address, signer: wallet, balance: balance, provider: provider }];
        }
    });
}); };
//# sourceMappingURL=index.js.map